<?PHP
/**************************** php ipblocker ****************************
*                     http://phpipblocker.evcz.tk                      *
*                             version 0.99j                            *
*                                                                      *
*     developed by EvolutionCrazy (AKA evcz) for B.I.S.S. forum ;)     *
*                                                                      *
*    Script distributed under GNU/GPL license (version 2 or higher)    *
*                                                                      *
*                   comments and suggestions here:                     *
*       http://www.bluetack.co.uk/forums/index.php?showforum=156       *
*                                                                      *
***********************************************************************/

//control if the script is already installed
if(file_exists('INSTALL.LOCK')){
	die('<b>php ipblocker</b> is already installed, to re-install/upgrade it you need to deleted the file <b>phpipblocker/INSTALL.LOCK</b>');
	exit();
}

define('_phpipblocker_dir_', './');

require_once('functions.php');
require_once('config.php');

if(!is_dir($ipblocker_config['fullpathLogName'])){
	$oldumask = umask(0);
	mkdir($ipblocker_config['fullpathLogName'], $ipblocker_config['fullpathLogName_chmod']);
	umask($oldumask);
	if(is_dir($ipblocker_config['fullpathLogName']))
		echo '<b>1</b>- Logging directory <i>'.$ipblocker_config['fullpathLogName'].'</i> successfully created and chmodded to <i>'.decoct($ipblocker_config['fullpathLogName_chmod']).'</i><br />';
	else
		die('The script wasn\'t able to create the logging directory at '.$ipblocker_config['fullpathLogName'].'... check the script is allowed to create that dir, otherwise you can create it manually.');
}
else
	echo '<b>1</b>- Logging directory <i>'.$ipblocker_config['fullpathLogName'].'</i> already exists... make sure it\'s correctly chmodded ;)<br />';

//mysql connection + db creation
if($ipblocker_config['persistent'])
	$ipblocker_config['connection_link'] = @mysql_pconnect($ipblocker_config['db_server'], $ipblocker_config['db_user'], $ipblocker_config['db_pass']) or die(mysql_error());
else
	$ipblocker_config['connection_link'] = @mysql_connect($ipblocker_config['db_server'], $ipblocker_config['db_user'], $ipblocker_config['db_pass']) or die(mysql_error());

//create database if not exists
mysql_query("CREATE DATABASE IF NOT EXISTS `".$ipblocker_config['db_name']."`", $ipblocker_config['connection_link']) or die(mysql_error());

echo "<br /><b>2</b>- Database <i>".$ipblocker_config['db_name']."</i> is ok<br />";

/*not ready
if($ipblocker_config['db_logging_active'] && $ipblocker_config['db_logging_name']!=$ipblocker_config['db_name']){
	mysql_query("CREATE DATABASE IF NOT EXISTS `".$ipblocker_config['db_logging_name']."`", $ipblocker_config['connection_link']) or die(mysql_error());
	echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Database <i>".$ipblocker_config['db_logging_name']."</i> is ok<br />";
}*/

//delete old table if exists
mysql_query('DROP TABLE IF EXISTS '.$ipblocker_config['db_name'].'.'.$ipblocker_config['db_table_name'], $ipblocker_config['connection_link']) or die(mysql_error());

//create the new table
$sql = "CREATE TABLE ".$ipblocker_config['db_name'].".".$ipblocker_config['db_table_name']." (
		`start` int(10) unsigned NOT NULL default '0',
  		`end` int(10) unsigned NOT NULL default '0',
		`rangename` varchar(64) NOT NULL default '',
		KEY `start` (`start`),
		KEY `end` (`end`),
		UNIQUE KEY `multi_sx` (`start`,`end`),
		UNIQUE KEY `multi_dx` (`end`,`start`)
		) TYPE=MyISAM;";
mysql_query($sql, $ipblocker_config['connection_link']) or die(mysql_error());

echo '<br /><b>3</b>- Table <i>'.$ipblocker_config['db_table_name'].'</i> successfully created on <i>'.$ipblocker_config['db_name'].'</i><br />';

/*not ready
if($ipblocker_config['db_logging_active']){
	//create new table if not exists
	mysql_query("CREATE TABLE IF NOT EXISTS ".$ipblocker_config['db_logging_name'].".".$ipblocker_config['db_logging_table_name']." (`date` int(10) unsigned NOT NULL default '0', `ip` int(10) unsigned NOT NULL default '0', `ip_forwaded_for` int(10) unsigned NOT NULL default '0', `requested_page` varchar(32) NOT NULL default '', `rangename` varchar(64) NOT NULL default '', `system` varchar(96) NOT NULL default '', KEY `date` (`date`), KEY `ip` (`ip`), KEY `ip_forwaded_for` (`ip_forwaded_for`))") or die(mysql_error());
	//print 'ok' message
	echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Table <i>".$ipblocker_config['db_logging_table_name']."</i> successfully created on ".$ipblocker_config['db_logging_name']."<br />";
}*/

if($ipblocker_config['caching_enable']){
	//delete old caching table if exists
	mysql_query('DROP TABLE IF EXISTS '.$ipblocker_config['db_name'].'.'.$ipblocker_config['caching_table'], $ipblocker_config['connection_link']) or die(mysql_error());
	//create new caching table
	$sql = "CREATE TABLE ".$ipblocker_config['db_name'].".".$ipblocker_config['caching_table']." (
			  `ip` int(10) unsigned NOT NULL default '0',
			  `time` int(10) unsigned NOT NULL default '0',
			  PRIMARY KEY  (`ip`)
			) TYPE=MyISAM;";
	mysql_query($sql, $ipblocker_config['connection_link']) or die(mysql_error());
	//print 'ok' message
	echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Table <i>".$ipblocker_config['caching_table']."</i> successfully created on <i>".$ipblocker_config['db_name']."</i><br />";
}

//fill the table with the blocklists
$stats = ipblocker_fillTable();

//close connection to the mysql server
ipblocker_disconnect();

//update the lastrun date (fakecron)
if($ipblocker_config['fakecron_enabled']){
	$fp = fopen ('update.lastrun.php', 'wb') or die('Error opening the update.lastrun.php file! cannot proceed... chmod it corretly (generally 775 or higher)');
	fwrite ($fp, '<'.'?php $'.'lastrun = '.time().'; ?'.'>') or die('Error writing the update.lastrun.php file! cannot proceed... chmod it corretly (generally 775 or higher)');
	fclose ($fp) or die('Error closing the update.lastrun.php file! cannot proceed... chmod it corretly (generally 777)');
	$oldumask = umask(0);
	chmod('update.lastrun.php', $ipblocker_config['fakecron_lastrun_chmod']);
	umask($oldumask);
}

//print messages
echo '<br /><b>4</b>- Block lists loaded<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.$stats['lists_number'].' lists processed<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.$stats['lists_skipped'].' lists skipped<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.$stats['rules_number'].' blocked ranges processed<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.$stats['rules_number_invalids'].' invalids lines detected<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.$stats['exclusions_rules_number'].' granted ranges processed<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;your '.$ipblocker_config['db_table_name'].' table now contains '.$stats['sql_rows'].' ranges<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;process completed in '.$stats['time'].' seconds<br />';

if (!ereg(DIRECTORY_SEPARATOR.'$', dirname(realpath(__FILE__))))
	$root = dirname(realpath(__FILE__)).DIRECTORY_SEPARATOR;
else
	$root = dirname(realpath(__FILE__));
	
if(DIRECTORY_SEPARATOR == '\\')
	$root = str_replace('\\', '\\\\', $root);

echo "<br /><b>Installation Completed</b>, now add this code at the beginning of the pages you want to protect:<br />
<textarea readonly cols=\"70\" rows=\"6\"><?PHP
//phpipblocker start
define('_phpipblocker_dir_', '".$root."');
require_once(_phpipblocker_dir_.'ban.php');
//phpipblocker end
?></textarea><br />
</i><br />
If you don't know where to put the lines above take a look at this thread:<br />
<a href=\"http://www.bluetack.co.uk/forums/index.php?showtopic=7705\" target=\"_blank\">http://www.bluetack.co.uk/forums/index.php?showtopic=7705</a><br /><br />
<b>Read docs/auto_updater.txt for info on how to use the <b>autoupdate</b> system.</b><br /><br />";

//create the INSTALL.LOCK file to lock your install process
$lock = @fopen('INSTALL.LOCK', 'a');
@fclose($lock);

//delete install.php file if lock procedure fails
if (!file_exists('INSTALL.LOCK')){
	echo 'Unable to lock install.php! ... i\'ll try to delete it...<br />';

	//delete install.php file
	unlink('install.php');
	if (file_exists('install.php'))
		echo 'I wasn\'t able to delete the <b>install.php</b> file, <b>delete it manually<b><br />';
	else
		echo 'The <b>install.php</b> file has been deleted<br />';
}
else
	echo 'The <b>install.php</b> now is locked, to run it again you need to delete the lock file: <b>phpipblocker/INSTALL.LOCK<b><br />';
	
//finished
echo '<br /><br /><center><b>Installation completed successfully</b></center><br />';

/**********************************************************************
* This script is free software; you can redistribute it and/or        *
* modify it under the terms of the GNU Lesser General Public          *
* License as published by the Free Software Foundation.               *
*                                                                     *
* This script is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of      *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU   *
* Lesser General Public License for more details.                     *
*                                                                     *
* You should have received a copy of the GNU Lesser General Public    *
* License along with this script; if not, write to the                *
* Free Software Foundation, Inc.,                                     *
* 59 Temple Place, Suite 330,                                         *
* Boston, MA                                                          *
* 02111-1307                                                          *
* USA                                                                 *
*                                                                     *
* For further information, visit www.gnu.org                          *
**********************************************************************/

?>