<?PHP
/**************************** php ipblocker ****************************
*                     http://phpipblocker.evcz.tk                      *
*                             version 0.99j                            *
*                                                                      *
*     developed by EvolutionCrazy (AKA evcz) for B.I.S.S. forum ;)     *
*                                                                      *
*    Script distributed under GNU/GPL license (version 2 or higher)    *
*                                                                      *
*                   comments and suggestions here:                     *
*       http://www.bluetack.co.uk/forums/index.php?showforum=156       *
*                                                                      *
***********************************************************************/

//security addons
if(!defined('_phpipblocker_dir_'))
	die('Nothing to see here');
	
//function to connect to the sql server
function ipblocker_connect(){
	global $ipblocker_config;

	//connect
	if($ipblocker_config['persistent'])
		$ipblocker_config['connection_link'] = @mysql_pconnect($ipblocker_config['db_server'], $ipblocker_config['db_user'], $ipblocker_config['db_pass']) or die('The phpipblocker script wasn\'t able to connect to the mysql server (persistent connection)...<br /><br />Inform the admin: '.$ipblocker_config['adminMail']);
	else
		$ipblocker_config['connection_link'] = @mysql_connect($ipblocker_config['db_server'], $ipblocker_config['db_user'], $ipblocker_config['db_pass']) or die('The phpipblocker script wasn\'t able to connect to the mysql server...<br /><br />Inform the admin: '.$ipblocker_config['adminMail']);

}

//function to disconnect from the sql server
function ipblocker_disconnect(){
	global $ipblocker_config;
	
	//disconnect
	if(!$ipblocker_config['persistent'] && $ipblocker_config['disconnect'])
		@mysql_close($ipblocker_config['connection_link']);

}

//function to fix ip
//transform 00x.00x.000.0xx in x.x.0.xx
function ipblocker_ipfixer($ip){
	$ip = explode('.',$ip);
	foreach($ip as $counter => $octet)
		$ip[$counter] = intval($octet);
	$ip = implode('.', $ip);
	return $ip;
}

//function to encode emails
function ipblocker_encode_mail($email){
	$email = str_replace('.', '<!-- encoded --><b></b>&nbsp;[<!-- encoded -->d<!-- encoded -->o<!-- encoded -->t<!-- encoded -->]&nbsp;<b></b><!-- encoded -->', $email);
	$email = str_replace('@', '<!-- encoded --><b></b>&nbsp;[<!-- encoded -->a<!-- encoded -->t<!-- encoded -->]&nbsp;<b></b><!-- encoded -->', $email);
	return $email;
}

function ipblocker_list_format($line){
	if(eregi('^(.*):([0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3})-([0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3})$', $line))
		return 'protowall';
	elseif(eregi('^([0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}) - ([0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}) , ([0-9]{1,5}) , (.*)$', $line))
		return 'donk';
	elseif(eregi('^([0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3})-([0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}),([0-9]{1,5}),(.*)$', $line))
		return 'donk_nospace';
	else
		return 'unknown';
}

function ipblocker_line_decode($line, $list_format){
	switch($list_format){
		case 'protowall':
			if(preg_match('/^(.*):([0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3})-([0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3})$/', $line, $data_preg)){
				$data['rangename'] = $data_preg['1'];
				$data['start'] = sprintf('%u', ip2long($data_preg['2']));
				$data['end'] = sprintf('%u', ip2long($data_preg['3']));
				if($data['start'] > $data['end'])
					$data = NULL;
			}
			else{
				$data = NULL;
			}
			break;
		case 'donk':
			if(preg_match('/^([0-9]{1,3}.[0-9]{1,3}.[0-9]{3}.[0-9]{1,3}) - ([0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}) , ([0-9]{1,5}) , (.*)$/', $line, $data_preg)){
				$data['rangename'] = $data_preg['4'];
				$data['start'] = sprintf('%u', ip2long(ipblocker_ipfixer($data_preg['1'])));
				$data['end'] = sprintf('%u', ip2long(ipblocker_ipfixer($data_preg['2'])));
				if($data['start'] > $data['end'])
					$data = NULL;
			}
			else{
				$data = NULL;
			}
			break;
		case 'donk_nospace':
			if(preg_match('/^([0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3})-([0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}),([0-9]{1,5}),(.*)$/', $line, $data_preg)){
				$data['rangename'] = $data_preg['4'];
				$data['start'] = sprintf('%u', ip2long(ipblocker_ipfixer($data_preg['1'])));
				$data['end'] = sprintf('%u', ip2long(ipblocker_ipfixer($data_preg['2'])));
				if($data['start'] > $data['end'])
					$data = NULL;
			}
			else{
				$data = NULL;
			}
			break;
		default:
			$data = NULL;
			break;
	}
	return $data;
}
	

function ipblocker_fillTable(){
	global $ipblocker_config, $ipblocker_listLocation, $ipblocker_exclusion;
	
	//start timer
	$mtime = microtime();
	$mtime = explode(' ',$mtime);
	$mtime = $mtime[1] + $mtime[0];
	$start_time = $mtime;
	//timer
	
	$stats['lists_number'] = 0;
	$stats['lists_skipped'] = 0;
	$stats['rules_number'] = 0;
	$stats['rules_number_invalids'] = 0;
	
	//empty the table
	@mysql_query('TRUNCATE '.$ipblocker_config['db_name'].'.'.$ipblocker_config['db_table_name'], $ipblocker_config['connection_link']);
	
	//inizialize the counter
	$i = 0;
	
	//inizialize query string for unique_query mode
	if($ipblocker_config['unique_query'])
		$query = 'INSERT IGNORE INTO '.$ipblocker_config['db_name'].'.'.$ipblocker_config['db_table_name'].' (`start`,`end`,`rangename`) VALUES ';
	
	//read and import a list at once
	foreach ($ipblocker_listLocation as $m => $fileLocation){
		++$stats['lists_number'];

		$mirrored_list = false;
		$remote_list = false;
		
		//mirror the list via CURL if necessary
		if(eregi('^http|^https|^ftp|^ftps', $fileLocation) && $ipblocker_config['use_curl_method']){
			$mirrored_list = true;
			$ch = curl_init($fileLocation);
			if(!eregi('.zip$', $fileLocation)){
				$fp = fopen('temp_list.tmp', 'w');
				curl_setopt($ch, CURLOPT_FILE, $fp);
				curl_setopt($ch, CURLOPT_HEADER, 0);
				curl_exec($ch);
				curl_close($ch);
				fclose($fp);
				$fileLocation = 'temp_list.tmp';
			}
			else{
				$fp = fopen('temp_list.zip', 'w');
				curl_setopt($ch, CURLOPT_FILE, $fp);
				curl_setopt($ch, CURLOPT_HEADER, 0);
				curl_exec($ch);
				curl_close($ch);
				fclose($fp);
				$fileLocation = 'temp_list.zip';
			}
		}

		//zip file handling		
		if(eregi('.zip$', $fileLocation)){
			if(function_exists('zip_open')){
				if(eregi('^http|^https|^ftp|^ftps', $fileLocation)){
					$remote_list = true;
					copy($fileLocation, basename($fileLocation));
					$fileLocation = basename($fileLocation);
				}
				//open the zip file
				$zip = zip_open(getcwd() . DIRECTORY_SEPARATOR . $fileLocation);
				//read the first file
				$zip_entry = zip_read($zip);
				//uncompress the file to a local temp list
				zip_entry_open($zip, $zip_entry, "r");
				$temp_list = fopen('temp_list.tmp', 'w');
				fwrite($temp_list, zip_entry_read($zip_entry, zip_entry_filesize($zip_entry)));
				fclose($temp_list);
				zip_entry_close($zip_entry);
				//close the zip file
				zip_close($zip);
				//delete the local temp list if necessary
				if($remote_list)
					unlink($fileLocation);
				$fileLocation = 'temp_list.tmp';
				$mirrored_list = true;
			}
			else{
				require_once('pclzip.lib.php');
				if(eregi('^http|^https|^ftp|^ftps', $fileLocation)){
					$remote_list = true;
					copy($fileLocation, basename($fileLocation));
					$fileLocation = basename($fileLocation);
				}
				$archive = new PclZip($fileLocation);
				$v_list = $archive->extractByIndex('0');
				if($remote_list)
					unlink($fileLocation);
				if ($v_list != 0){
					$fileLocation = $v_list['0']['stored_filename'];
					rename($fileLocation, 'temp_list.tmp');
					$fileLocation = 'temp_list.tmp';
					$mirrored_list = true;
				}
			}
		}
		//ended zip file handling

		//intialize format list to false
		$format_checked = false;
		
		//try to open the list
		if($lines = @gzfile($fileLocation)){
			foreach ($lines as $k => $line){
	
				//remove newlines
				$line = trim($line);
	
				//check what type of list we are using
				if(!$format_checked){
					$list_format = ipblocker_list_format($line);
					$format_checked = true;
				}
				
				//if the format of the list is unsupported we skip this list
				if($list_format === 'unknown'){
					++$stats['lists_skipped'];
					--$stats['lists_number'];
					break;
				}
				
				//decode the line according to the routine related to the list type in use
				$data = ipblocker_line_decode($line, $list_format);
				
				//start <= end? yes... proceed with the insertion ;)			
				if($data != NULL){
					++$stats['rules_number'];	
					//add slashes
					//if (!get_magic_quotes_gpc())
						$data['rangename'] = addslashes($data['rangename']);
					
					if($ipblocker_config['unique_query']){
						if($i != 0)
							$query .= ',';
						$query .=  '(\''.$data['start'].'\',\''.$data['end'].'\',\''.$data['rangename'].'\')';
						
						++$i;
						
						if($i == $ipblocker_config['lines_per_query']){
							@mysql_query($query, $ipblocker_config['connection_link']);
							$query = 'INSERT IGNORE INTO '.$ipblocker_config['db_name'].'.'.$ipblocker_config['db_table_name'].' (`start`,`end`,`rangename`) VALUES ';
							$i = 0;
						}
					}
					else
						@mysql_query('INSERT IGNORE INTO '.$ipblocker_config['db_name'].'.'.$ipblocker_config['db_table_name'].' (`start`,`end`,`rangename`) VALUES (\''.$data['start'].'\',\''.$data['end'].'\',\''.$data['rangename'].'\')', $ipblocker_config['connection_link']);
				}
				else{
					$stats['rules_number_invalids']++;
				}
			}
			//delete the temporary list (created with zipped lists)
			if($mirrored_list)
				unlink($fileLocation);
		}
		else{
			echo('<br />Unable to load <b>'.$fileLocation.'</b>... list skipped!<br />');
			++$stats['lists_skipped'];
			--$stats['lists_number'];
		}
	}
	if($ipblocker_config['unique_query']){
		@mysql_query($query, $ipblocker_config['connection_link']);
	}
	//finished importing the lists
	
	//exclusion lists process
	$stats['exclusions_rules_number'] = 0;
	if(isset($ipblocker_exclusion)){
		foreach ($ipblocker_exclusion as $m => $fileLocation){

			//intial format list values
			$format_checked = false;
			
			++$stats['lists_number'];
			
			$mirrored_list = false;
			$remote_list = false;
			
			//mirror the list via CURL if necessary
			if(eregi('^http|^https|^ftp|^ftps', $fileLocation) && $ipblocker_config['use_curl_method']){
				$mirrored_list = true;
				$ch = curl_init($fileLocation);
				if(!eregi('.zip$', $fileLocation)){
					$fp = fopen('temp_list.tmp', 'w');
					curl_setopt($ch, CURLOPT_FILE, $fp);
					curl_setopt($ch, CURLOPT_HEADER, 0);
					curl_exec($ch);
					curl_close($ch);
					fclose($fp);
					$fileLocation = 'temp_list.tmp';
				}
				else{
					$fp = fopen('temp_list.zip', 'w');
					curl_setopt($ch, CURLOPT_FILE, $fp);
					curl_setopt($ch, CURLOPT_HEADER, 0);
					curl_exec($ch);
					curl_close($ch);
					fclose($fp);
					$fileLocation = 'temp_list.zip';
				}
			}

			//zip file handling
			if(eregi('.zip$', $fileLocation)){
				if(function_exists('zip_open')){
					if(eregi('^http|^https|^ftp|^ftps', $fileLocation)){
						$remote_list = true;
						copy($fileLocation, basename($fileLocation));
						$fileLocation = basename($fileLocation);
					}
					//open the zip file
					$zip = zip_open(getcwd() . DIRECTORY_SEPARATOR . $fileLocation);
					//read the first file
					$zip_entry = zip_read($zip);
					//uncompress the file to a local temp list
					zip_entry_open($zip, $zip_entry, "r");
					$temp_list = fopen('temp_list.tmp', 'w');
					fwrite($temp_list, zip_entry_read($zip_entry, zip_entry_filesize($zip_entry)));
					fclose($temp_list);
					zip_entry_close($zip_entry);
					//close the zip file
					zip_close($zip);
					//delete the local temp list if necessary
					if($remote_list)
						unlink($fileLocation);
					$fileLocation = 'temp_list.tmp';
					$mirrored_list = true;
				}
				else{
					require_once('pclzip.lib.php');
					if(eregi('^http|^https|^ftp|^ftps', $fileLocation)){
						$remote_list = true;
						copy($fileLocation, basename($fileLocation));
						$fileLocation = basename($fileLocation);
					}
					$archive = new PclZip($fileLocation);
					$v_list = $archive->extractByIndex('0');
					if($remote_list)
						unlink($fileLocation);
					if ($v_list != 0){
						$fileLocation = $v_list['0']['stored_filename'];
						rename($fileLocation, 'temp_list.tmp');
						$fileLocation = 'temp_list.tmp';
						$mirrored_list = true;
					}
				}
			}
			//ended zip file handling
	
			//try to open the list
			if($lines = @gzfile($fileLocation)){
				foreach ($lines as $k => $line){
					//remove newlines
					$line = trim($line);
		
					//check what type of list we are using
					if(!$format_checked){
						$list_format = ipblocker_list_format($line);
						$format_checked = true;
					}
					
					//if the format of the list is unsupported we skip this list
					if($list_format == 'unknown'){
						++$stats['lists_skipped'];
						--$stats['lists_number'];
						break;
					}
					
					//decode the line according to the routine related to the list type in use
					$data = ipblocker_line_decode($line, $list_format);

					//start <= end? yes... proceed with the insertion ;)			
					if($data != NULL){
						++$stats['exclusions_rules_number'];
						
						//add slashes
						//if (!get_magic_quotes_gpc())
							$data['rangename'] = addslashes($data['rangename']);

						//search for encapsulated ranges
						$result = @mysql_query('SELECT * FROM '.$ipblocker_config['db_name'].'.'.$ipblocker_config['db_table_name'].' WHERE start <= \''.$data['start'].'\' AND end >= \''.$data['end'].'\'', $ipblocker_config['connection_link']);
						if(mysql_num_rows($result) > 0){
							while($result_fetched = mysql_fetch_array($result)){
								//same start different end
								//exclusion_start = start < exclusion_end < end
								if($result_fetched['start'] == $data['start'] && $result_fetched['end'] != $data['end'])
									@mysql_query('UPDATE '.$ipblocker_config['db_name'].'.'.$ipblocker_config['db_table_name'].' SET start = \''.($data['end']+1).'\' WHERE start = \''.$result_fetched['start'].'\' AND end = \''.$result_fetched['end'].'\'', $ipblocker_config['connection_link']);
								//different start, same end
								//start < exclusion_start < end = exclusion_end
								elseif($result_fetched['start'] != $data['start'] && $result_fetched['end'] == $data['end'])
									@mysql_query('UPDATE '.$ipblocker_config['db_name'].'.'.$ipblocker_config['db_table_name'].' SET end = \''.($data['start']-1).'\' WHERE start = \''.$result_fetched['start'].'\' AND end = \''.$result_fetched['end'].'\'', $ipblocker_config['connection_link']);
								//start and end different
								//start < exclusion_start <= exclusion_end < end
								else{
									@mysql_query('UPDATE '.$ipblocker_config['db_name'].'.'.$ipblocker_config['db_table_name'].' SET end = \''.($data['start']-1).'\' WHERE start = \''.$result_fetched['start'].'\' AND end = \''.$result_fetched['end'].'\'', $ipblocker_config['connection_link']);
									@mysql_query('INSERT IGNORE INTO '.$ipblocker_config['db_name'].'.'.$ipblocker_config['db_table_name'].' (`start`,`end`,`rangename`) VALUES (\''.($data['end']+1).'\',\''.$result_fetched['end'].'\',\''.addslashes(stripslashes($result_fetched['rangename'])).'\')', $ipblocker_config['connection_link']);
								}
							}
						}
						//ended encapsulated ranges
						
						//ITA: maggiore sia a destra che a sinistra (anche coincidenti)
						//exclusion_start <= start < end <= exclusion_end
						@mysql_query('DELETE FROM '.$ipblocker_config['db_name'].'.'.$ipblocker_config['db_table_name'].' WHERE start >= \''.$data['start'].'\' AND end <= \''.$data['end'].'\'', $ipblocker_config['connection_link']);
						//end
						
						//ITA: maggiore a destra, interno a sinistra
						//start < exclusion_start < end < exclusion_end
						$result = @mysql_query('SELECT start, end FROM '.$ipblocker_config['db_name'].'.'.$ipblocker_config['db_table_name'].' WHERE start <= \''.$data['start'].'\' AND end >= \''.$data['start'].'\' AND end < \''.$data['end'].'\'', $ipblocker_config['connection_link']);
						if(mysql_num_rows($result) > 0){
							while($result_fetched = mysql_fetch_array($result)){
								@mysql_query('UPDATE '.$ipblocker_config['db_name'].'.'.$ipblocker_config['db_table_name'].' SET end = \''.($data['start']-1).'\' WHERE start = \''.$result_fetched['start'].'\' AND end = \''.$result_fetched['end'].'\'', $ipblocker_config['connection_link']);
							}
						}
						//end
		
						//ITA: minore a sinistra, interno a destra
						//exclusion_start < start < exclusion_end < end
						$result = @mysql_query('SELECT start, end FROM '.$ipblocker_config['db_name'].'.'.$ipblocker_config['db_table_name'].' WHERE start <= \''.$data['end'].'\' AND end >= \''.$data['end'].'\' start > \''.$data['start'].'\'');
						if(@mysql_num_rows($result) > 0){
							while($result_fetched = mysql_fetch_array($result)){
								@mysql_query('UPDATE '.$ipblocker_config['db_name'].'.'.$ipblocker_config['db_table_name'].' SET start = \''.($data['end']+1).'\' WHERE start = \''.$result_fetched['start'].'\' AND end = \''.$result_fetched['end'].'\'');
							}
						}
						//end
					}
				}
			}
			else{
				echo('<br />Unable to load <b>'.$fileLocation.'</b>... list skipped!<br />');
				$stats['lists_skipped']++;
				$stats['lists_number']--;
			}
		}
	}
	//finished exclusions process

	//optimize the table
	@mysql_query('OPTIMIZE TABLE '.$ipblocker_config['db_name'].'.'.$ipblocker_config['db_table_name'], $ipblocker_config['connection_link']);
	//@mysql_query('ALTER TABLE '.$ipblocker_config['db_name'].'.'.$ipblocker_config['db_table_name'].' ORDER BY `start`', $ipblocker_config['connection_link']);

	//count real number of rows	
	$sql_rows = @mysql_query('SELECT COUNT(*) FROM '.$ipblocker_config['db_name'].'.'.$ipblocker_config['db_table_name'], $ipblocker_config['connection_link']);
	$sql_rows = @mysql_fetch_array($sql_rows);
	$stats['sql_rows'] = ''.$sql_rows['0'].'';
	
	//end timer
	$mtime = microtime();
	$mtime = explode(' ',$mtime);
	$mtime = $mtime[1] + $mtime[0];
	$end_time = $mtime;
	//timer
	
	$stats['time'] = round($end_time-$start_time,3);

	return $stats;
}

//file logging function
function ipblocker_filelogger($file, $line){
	if(!$fp = @fopen($file, 'a')) return FALSE;
	if(!@fwrite($fp, $line)) return FALSE;
	if(!@fclose($fp)) return FALSE;
	return TRUE;
}

/**********************************************************************
* This script is free software; you can redistribute it and/or        *
* modify it under the terms of the GNU Lesser General Public          *
* License as published by the Free Software Foundation.               *
*                                                                     *
* This script is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of      *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU   *
* Lesser General Public License for more details.                     *
*                                                                     *
* You should have received a copy of the GNU Lesser General Public    *
* License along with this script; if not, write to the                *
* Free Software Foundation, Inc.,                                     *
* 59 Temple Place, Suite 330,                                         *
* Boston, MA                                                          *
* 02111-1307                                                          *
* USA                                                                 *
*                                                                     *
* For further information, visit www.gnu.org                          *
**********************************************************************/

?>